<?php
/*
  Plugin Name: WP Sgv
  Plugin URI: http://midoriit.com/works/wp-sgv.html
  Description: Visualize SPARQL query result using Sgvizler
  Version: 0.3.1
  Author: Midori IT Office LLC
  Author URI: http://midoriit.com/
  License: GPL3
*/

function wp_sgv_handler( $atts, $content ) {

  extract( shortcode_atts( array(
    'endpoint' => '',
    'chart' => 'sgvizler.visualization.Text',
    'options' => '',
    'height' => '100',
    'width' => '100'),
      $atts ) );

  $query = str_replace(array("\r\n","\r","\n","<br />","<br>","</br>","<p>","</p>"), ' ', $content);

  if( empty($endpoint) ) {
    return 'no endpoint';
  } else if( !trim($query) ) {
    return 'no query';
  }

  $uniq = uniqid('',1);

  return 
  '<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.9.0/jquery.js"></script>
  <script type="text/javascript" src="https://www.google.com/jsapi"></script>
  <script type="text/javascript" src="http://beta.data2000.no/sgvizler/release/0.6/sgvizler.js"></script>
  <div id="sgvdiv'.$uniq.'"></div>
  <script type="text/javascript">
    var sparqlQueryString = "'.$query.'";
    q = new sgvizler.Query(null, {'.$options.'});
    q.query(sparqlQueryString)
      .endpointURL("'.$endpoint.'")
      .endpointOutputFormat("json")
      .chartFunction("'.$chart.'")
      .chartHeight("'.$height.'")
      .chartWidth("'.$width.'")
      .draw("sgvdiv'.$uniq.'");
  </script>';
}

add_shortcode('wp_sgv', 'wp_sgv_handler');
?>
